Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/NST/agrif_user.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/NST/agrif_user.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/NST/agrif_user.F90	(revision 13026)
@@ -532,10 +656,17 @@
       !                            2,2 = two ghost lines
       !-------------------------------------------------------------------------------------
+
       ind1 =     nbghostcells
-      ind2 = 1 + nbghostcells
-      ind3 = 2 + nbghostcells
-      CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpl*(8+nlay_s+nlay_i)/),tra_ice_id)
-      CALL agrif_declare_variable((/1,2/)  ,(/ind2,ind3/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,u_ice_id  )
-      CALL agrif_declare_variable((/2,1/)  ,(/ind3,ind2/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,v_ice_id  )
+      ind2 = 2 + nbghostcells_x
+      ind3 = 2 + nbghostcells_y_s
+      CALL agrif_declare_variable((/2,2,0/),(/ind2,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpl*(8+nlay_s+nlay_i)/),tra_ice_id)
+      CALL agrif_declare_variable((/1,2/)  ,(/ind2-1,ind3/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,u_ice_id  )
+      CALL agrif_declare_variable((/2,1/)  ,(/ind2,ind3-1/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,v_ice_id  )
+
+      CALL Agrif_Set_MaskMaxSearch(25)
+      CALL agrif_declare_variable((/2,2,0/),(/ind3,ind3,0/),(/'x','y','N'/),(/1,1,1/),(/nlci,nlcj,jpl*(8+nlay_s+nlay_i)/),tra_iceini_id)
+      CALL agrif_declare_variable((/1,2/)  ,(/ind2-1,ind3/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,u_iceini_id  )
+      CALL agrif_declare_variable((/2,1/)  ,(/ind2,ind3-1/)  ,(/'x','y'/)    ,(/1,1/)  ,(/nlci,nlcj/)                      ,v_iceini_id  )
+      CALL Agrif_Set_MaskMaxSearch(5)
 
       ! 2. Set interpolations (normal & tangent to the grid cell for velocities)
@@ -545,4 +676,11 @@
       CALL Agrif_Set_bcinterp(v_ice_id  , interp1 = AGRIF_ppm   ,interp2 = Agrif_linear)
 
+      CALL Agrif_Set_bcinterp(tra_iceini_id, interp  = AGRIF_linear)
+      CALL Agrif_Set_interp  (tra_iceini_id, interp  = AGRIF_linear)
+      CALL Agrif_Set_bcinterp(u_iceini_id  , interp  = AGRIF_linear  )
+      CALL Agrif_Set_interp  (u_iceini_id  , interp  = AGRIF_linear   )
+      CALL Agrif_Set_bcinterp(v_iceini_id  , interp  = AGRIF_linear)
+      CALL Agrif_Set_interp  (v_iceini_id  , interp  = AGRIF_linear)
+
       ! 3. Set location of interpolations
       !----------------------------------
@@ -550,4 +688,8 @@
       CALL Agrif_Set_bc(u_ice_id  ,(/0,ind1/))
       CALL Agrif_Set_bc(v_ice_id  ,(/0,ind1/))
+
+      CALL Agrif_Set_bc(tra_iceini_id,(/0,ind1/))
+      CALL Agrif_Set_bc(u_iceini_id  ,(/0,ind1/))
+      CALL Agrif_Set_bc(v_iceini_id  ,(/0,ind1/))
 
       ! 4. Set update type in case 2 ways (child=>parent) (normal & tangent to the grid cell for velocities)
@@ -557,9 +699,9 @@
       CALL Agrif_Set_Updatetype(u_ice_id  , update1 = Agrif_Update_Average       , update2 = Agrif_Update_Full_Weighting)
       CALL Agrif_Set_Updatetype(v_ice_id  , update1 = Agrif_Update_Full_Weighting, update2 = Agrif_Update_Average       )
-#else
+# else
       CALL Agrif_Set_Updatetype(tra_ice_id, update  = AGRIF_Update_Average)
       CALL Agrif_Set_Updatetype(u_ice_id  , update1 = Agrif_Update_Copy   , update2 = Agrif_Update_Average)
       CALL Agrif_Set_Updatetype(v_ice_id  , update1 = Agrif_Update_Average, update2 = Agrif_Update_Copy   )
-#endif
+# endif
 
    END SUBROUTINE agrif_declare_var_ice
@@ -585,36 +727,39 @@
       USE agrif_top_sponge
       !!
-      IMPLICIT NONE
-      !
-      CHARACTER(len=10) :: cl_check1, cl_check2, cl_check3
-      LOGICAL :: check_namelist
-      !!----------------------------------------------------------------------
-
-      ! 1. Declaration of the type of variable which have to be interpolated
-      !---------------------------------------------------------------------
-      CALL agrif_declare_var_top
-
-      ! 2. First interpolations of potentially non zero fields
-      !-------------------------------------------------------
-      Agrif_SpecialValue=0._wp
-      Agrif_UseSpecialValue = .TRUE.
-      CALL Agrif_Bc_variable(trn_id,calledweight=1.,procname=interptrn)
-      Agrif_UseSpecialValue = .FALSE.
-      CALL Agrif_Sponge
-      tabspongedone_trn = .FALSE.
-      CALL Agrif_Bc_variable(trn_sponge_id,calledweight=1.,procname=interptrn_sponge)
-      ! reset ts(:,:,:,:,Krhs_a) to zero
-      tr(:,:,:,:,Krhs_a) = 0._wp
-
-      ! 3. Some controls
-      !-----------------
-      check_namelist = .TRUE.
-
-      IF( check_namelist ) THEN
-         ! Check time steps
-      IF( NINT(Agrif_Rhot()) * NINT(rn_Dt) .NE. Agrif_Parent(rn_Dt) ) THEN
-         WRITE(cl_check1,*)  Agrif_Parent(rn_Dt)
-         WRITE(cl_check2,*)  rn_Dt
-         WRITE(cl_check3,*)  rn_Dt*Agrif_Rhot()
+  
+   !!
+   IMPLICIT NONE
+   !
+   CHARACTER(len=10) :: cl_check1, cl_check2, cl_check3
+   LOGICAL :: check_namelist
+      !!----------------------------------------------------------------------
+
+
+   ! 1. Declaration of the type of variable which have to be interpolated
+   !---------------------------------------------------------------------
+   CALL agrif_declare_var_top
+
+   ! 2. First interpolations of potentially non zero fields
+   !-------------------------------------------------------
+   Agrif_SpecialValue=0.
+   Agrif_UseSpecialValue = .TRUE.
+   CALL Agrif_Bc_variable(trn_id,calledweight=1.,procname=interptrn)
+   Agrif_UseSpecialValue = .FALSE.
+   CALL Agrif_Sponge
+   tabspongedone_trn = .FALSE.
+   CALL Agrif_Bc_variable(trn_sponge_id,calledweight=1.,procname=interptrn_sponge)
+   ! reset tsa to zero
+   tra(:,:,:,:) = 0.
+
+   ! 3. Some controls
+   !-----------------
+   check_namelist = .TRUE.
+
+   IF( check_namelist ) THEN
+      ! Check time steps
+      IF( NINT(Agrif_Rhot()) * NINT(rdt) .NE. Agrif_Parent(rdt) ) THEN
+         WRITE(cl_check1,*)  Agrif_Parent(rdt)
+         WRITE(cl_check2,*)  rdt
+         WRITE(cl_check3,*)  rdt*Agrif_Rhot()
          CALL ctl_stop( 'incompatible time step between grids',   &
                &               'parent grid value : '//cl_check1    ,   & 
@@ -635,5 +780,4 @@
          nitend =  Agrif_Parent(nitend)   *Agrif_IRhot()
       ENDIF
-
    ENDIF
    !
@@ -655,15 +799,19 @@
       !!----------------------------------------------------------------------
 
+
+
+!RB_CMEMS : declare here init for top      
       ! 1. Declaration of the type of variable which have to be interpolated
       !---------------------------------------------------------------------
       ind1 =     nbghostcells
-      ind2 = 1 + nbghostcells
-      ind3 = 2 + nbghostcells
+      ind2 = 2 + nbghostcells_x
+      ind3 = 2 + nbghostcells_y_s
 # if defined key_vertical
-      CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra+1/),trn_id)
-      CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra+1/),trn_sponge_id)
+      CALL agrif_declare_variable((/2,2,0,0/),(/ind2,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra+1/),trn_id)
+      CALL agrif_declare_variable((/2,2,0,0/),(/ind2,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra+1/),trn_sponge_id)
 # else
-      CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra/),trn_id)
-      CALL agrif_declare_variable((/2,2,0,0/),(/ind3,ind3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra/),trn_sponge_id)
+! LAURENT: STRANGE why (3,3) here ?
+      CALL agrif_declare_variable((/2,2,0,0/),(/3,3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra/),trn_id)
+      CALL agrif_declare_variable((/2,2,0,0/),(/3,3,0,0/),(/'x','y','N','N'/),(/1,1,1,1/),(/nlci,nlcj,jpk,jptra/),trn_sponge_id)
 # endif
 
@@ -705,8 +853,9 @@
       !!                     *** ROUTINE agrif_init ***
       !!----------------------------------------------------------------------
-      USE agrif_oce 
-      USE agrif_ice
-      USE in_out_manager
-      USE lib_mpp
+   USE agrif_oce 
+   USE agrif_ice
+   USE dom_oce
+   USE in_out_manager
+   USE lib_mpp
       !!
       IMPLICIT NONE
@@ -714,5 +863,5 @@
       INTEGER  ::   ios                 ! Local integer output status for namelist read
       NAMELIST/namagrif/ ln_agrif_2way, rn_sponge_tra, rn_sponge_dyn, rn_trelax_tra, rn_trelax_dyn, &
-                       & ln_spc_dyn, ln_chk_bathy
+                       & ln_spc_dyn, ln_chk_bathy, ln_bry_south
       !!--------------------------------------------------------------------------------------
       !
@@ -735,13 +884,25 @@
          WRITE(numout,*) '      use special values for dynamics   ln_spc_dyn    = ', ln_spc_dyn
          WRITE(numout,*) '      check bathymetry                  ln_chk_bathy  = ', ln_chk_bathy
-      ENDIF
-      !
-      !
-      IF( agrif_oce_alloc()  > 0 )   CALL ctl_warn('agrif agrif_oce_alloc: allocation of arrays failed')
+         WRITE(numout,*) '      south boundary                    ln_bry_south  = ', ln_bry_south
+      ENDIF
+      !
+      ! Set the number of ghost cells according to periodicity
+      nbghostcells_x = nbghostcells
+      nbghostcells_y_s = nbghostcells
+      nbghostcells_y_n = nbghostcells
+      !
+      IF ( jperio == 1 ) nbghostcells_x = 0
+      IF ( .NOT. ln_bry_south ) nbghostcells_y_s = 0
+
+      ! Some checks
+      IF( jpiglo /= nbcellsx + 2 + 2*nbghostcells_x )   &
+          CALL ctl_stop( 'STOP', 'agrif_nemo_init: Agrif children requires jpiglo == nbcellsx + 2 + 2*nbghostcells_x' )
+      IF( jpjglo /= nbcellsy + 2 + nbghostcells_y_s + nbghostcells_y_n )   &
+          CALL ctl_stop( 'STOP', 'agrif_nemo_init: Agrif children requires jpjglo == nbcellsy + 2 + nbghostcells_y_s + nbghostcells_y_n' )
+      IF( ln_use_jattr )   CALL ctl_stop( 'STOP', 'agrif_nemo_init:Agrif children requires ln_use_jattr = .false. ' )
       !
    END SUBROUTINE agrif_nemo_init
 
 # if defined key_mpp_mpi
-
    SUBROUTINE Agrif_InvLoc( indloc, nprocloc, i, indglob )
       !!----------------------------------------------------------------------
@@ -803,4 +964,231 @@
 # endif
 
+   SUBROUTINE nemo_mapping(ndim,ptx,pty,bounds,bounds_chunks,correction_required,nb_chunks)
+      !!----------------------------------------------------------------------
+      !!                   *** ROUTINE Nemo_mapping ***
+      !!----------------------------------------------------------------------
+      USE dom_oce
+      !!
+      IMPLICIT NONE
+      !
+      INTEGER :: ndim
+      INTEGER :: ptx, pty
+      INTEGER, DIMENSION(ndim,2,2) :: bounds
+      INTEGER, DIMENSION(:,:,:,:), ALLOCATABLE :: bounds_chunks
+      LOGICAL, DIMENSION(:), ALLOCATABLE :: correction_required
+      INTEGER :: nb_chunks
+      !
+      INTEGER :: i
+
+      IF (agrif_debug_interp) THEN
+         DO i=1,ndim
+            WRITE(*,*) 'direction = ',i,bounds(i,1,2),bounds(i,2,2)
+         ENDDO
+      ENDIF
+
+      IF( bounds(2,2,2) > jpjglo) THEN
+         IF( bounds(2,1,2) <=jpjglo) THEN
+            nb_chunks = 2
+            ALLOCATE(bounds_chunks(nb_chunks,ndim,2,2))
+            ALLOCATE(correction_required(nb_chunks))
+            DO i = 1,nb_chunks
+               bounds_chunks(i,:,:,:) = bounds
+            END DO
+        
+      ! FIRST CHUNCK (for j<=jpjglo)   
+
+      ! Original indices
+            bounds_chunks(1,1,1,1) = bounds(1,1,2)
+            bounds_chunks(1,1,2,1) = bounds(1,2,2)
+            bounds_chunks(1,2,1,1) = bounds(2,1,2)
+            bounds_chunks(1,2,2,1) = jpjglo
+
+            bounds_chunks(1,1,1,2) = bounds(1,1,2)
+            bounds_chunks(1,1,2,2) = bounds(1,2,2)
+            bounds_chunks(1,2,1,2) = bounds(2,1,2)
+            bounds_chunks(1,2,2,2) = jpjglo
+
+      ! Correction required or not
+            correction_required(1)=.FALSE.
+       
+      ! SECOND CHUNCK (for j>jpjglo)
+
+      ! Original indices
+            bounds_chunks(2,1,1,1) = bounds(1,1,2)
+            bounds_chunks(2,1,2,1) = bounds(1,2,2)
+            bounds_chunks(2,2,1,1) = jpjglo-2
+            bounds_chunks(2,2,2,1) = bounds(2,2,2)
+
+      ! Where to find them
+      ! We use the relation TAB(ji,jj)=TAB(jpiglo-ji+2,jpjglo-2-(jj-jpjglo))
+
+            IF( ptx == 2) THEN ! T, V points
+               bounds_chunks(2,1,1,2) = jpiglo-bounds(1,2,2)+2
+               bounds_chunks(2,1,2,2) = jpiglo-bounds(1,1,2)+2
+            ELSE ! U, F points
+               bounds_chunks(2,1,1,2) = jpiglo-bounds(1,2,2)+1
+               bounds_chunks(2,1,2,2) = jpiglo-bounds(1,1,2)+1       
+            ENDIF
+
+            IF( pty == 2) THEN ! T, U points
+               bounds_chunks(2,2,1,2) = jpjglo-2-(bounds(2,2,2) -jpjglo)
+               bounds_chunks(2,2,2,2) = jpjglo-2-(jpjglo-2      -jpjglo)
+            ELSE ! V, F points
+               bounds_chunks(2,2,1,2) = jpjglo-3-(bounds(2,2,2) -jpjglo)
+               bounds_chunks(2,2,2,2) = jpjglo-3-(jpjglo-2      -jpjglo)
+            ENDIF
+      ! Correction required or not
+            correction_required(2)=.TRUE.
+
+         ELSE
+            nb_chunks = 1
+            ALLOCATE(bounds_chunks(nb_chunks,ndim,2,2))
+            ALLOCATE(correction_required(nb_chunks))
+            DO i=1,nb_chunks
+               bounds_chunks(i,:,:,:) = bounds
+            END DO
+
+            bounds_chunks(1,1,1,1) = bounds(1,1,2)
+            bounds_chunks(1,1,2,1) = bounds(1,2,2)
+            bounds_chunks(1,2,1,1) = bounds(2,1,2)
+            bounds_chunks(1,2,2,1) = bounds(2,2,2)
+
+            bounds_chunks(1,1,1,2) = jpiglo-bounds(1,2,2)+2
+            bounds_chunks(1,1,2,2) = jpiglo-bounds(1,1,2)+2
+
+            bounds_chunks(1,2,1,2) = jpjglo-2-(bounds(2,2,2)-jpjglo)
+            bounds_chunks(1,2,2,2) = jpjglo-2-(bounds(2,1,2)-jpjglo)
+
+            IF( ptx == 2) THEN ! T, V points
+               bounds_chunks(1,1,1,2) = jpiglo-bounds(1,2,2)+2
+               bounds_chunks(1,1,2,2) = jpiglo-bounds(1,1,2)+2
+            ELSE ! U, F points
+               bounds_chunks(1,1,1,2) = jpiglo-bounds(1,2,2)+1
+               bounds_chunks(1,1,2,2) = jpiglo-bounds(1,1,2)+1    	
+            ENDIF
+
+            IF (pty == 2) THEN ! T, U points
+               bounds_chunks(1,2,1,2) = jpjglo-2-(bounds(2,2,2) -jpjglo)
+               bounds_chunks(1,2,2,2) = jpjglo-2-(bounds(2,1,2) -jpjglo)
+            ELSE ! V, F points
+               bounds_chunks(1,2,1,2) = jpjglo-3-(bounds(2,2,2) -jpjglo)
+               bounds_chunks(1,2,2,2) = jpjglo-3-(bounds(2,1,2) -jpjglo)
+            ENDIF
+
+            correction_required(1)=.TRUE.          
+         ENDIF
+
+      ELSE IF (bounds(1,1,2) < 1) THEN
+         IF (bounds(1,2,2) > 0) THEN
+            nb_chunks = 2
+            ALLOCATE(correction_required(nb_chunks))
+            correction_required=.FALSE.
+            ALLOCATE(bounds_chunks(nb_chunks,ndim,2,2))
+            DO i=1,nb_chunks
+               bounds_chunks(i,:,:,:) = bounds
+            END DO
+              
+            bounds_chunks(1,1,1,2) = bounds(1,1,2)+jpiglo-2
+            bounds_chunks(1,1,2,2) = 1+jpiglo-2
+          
+            bounds_chunks(1,1,1,1) = bounds(1,1,2)
+            bounds_chunks(1,1,2,1) = 1
+       
+            bounds_chunks(2,1,1,2) = 2
+            bounds_chunks(2,1,2,2) = bounds(1,2,2)
+          
+            bounds_chunks(2,1,1,1) = 2
+            bounds_chunks(2,1,2,1) = bounds(1,2,2)
+
+         ELSE
+            nb_chunks = 1
+            ALLOCATE(correction_required(nb_chunks))
+            correction_required=.FALSE.
+            ALLOCATE(bounds_chunks(nb_chunks,ndim,2,2))
+            DO i=1,nb_chunks
+               bounds_chunks(i,:,:,:) = bounds
+            END DO    
+            bounds_chunks(1,1,1,2) = bounds(1,1,2)+jpiglo-2
+            bounds_chunks(1,1,2,2) = bounds(1,2,2)+jpiglo-2
+          
+            bounds_chunks(1,1,1,1) = bounds(1,1,2)
+           bounds_chunks(1,1,2,1) = bounds(1,2,2)
+         ENDIF
+      ELSE
+         nb_chunks=1  
+         ALLOCATE(correction_required(nb_chunks))
+         correction_required=.FALSE.
+         ALLOCATE(bounds_chunks(nb_chunks,ndim,2,2))
+         DO i=1,nb_chunks
+            bounds_chunks(i,:,:,:) = bounds
+         END DO
+         bounds_chunks(1,1,1,2) = bounds(1,1,2)
+         bounds_chunks(1,1,2,2) = bounds(1,2,2)
+         bounds_chunks(1,2,1,2) = bounds(2,1,2)
+         bounds_chunks(1,2,2,2) = bounds(2,2,2)
+          
+         bounds_chunks(1,1,1,1) = bounds(1,1,2)
+         bounds_chunks(1,1,2,1) = bounds(1,2,2)
+         bounds_chunks(1,2,1,1) = bounds(2,1,2)
+         bounds_chunks(1,2,2,1) = bounds(2,2,2)              
+      ENDIF
+        
+   END SUBROUTINE nemo_mapping
+
+   FUNCTION agrif_external_switch_index(ptx,pty,i1,isens)
+
+   USE dom_oce
+
+   INTEGER :: ptx, pty, i1, isens
+   INTEGER :: agrif_external_switch_index
+
+   IF( isens == 1 ) THEN
+      IF( ptx == 2 ) THEN ! T, V points
+         agrif_external_switch_index = jpiglo-i1+2
+      ELSE ! U, F points
+         agrif_external_switch_index = jpiglo-i1+1      
+      ENDIF
+   ELSE IF( isens ==2 ) THEN
+      IF ( pty == 2 ) THEN ! T, U points
+         agrif_external_switch_index = jpjglo-2-(i1 -jpjglo)
+      ELSE ! V, F points
+         agrif_external_switch_index = jpjglo-3-(i1 -jpjglo)
+      ENDIF
+   ENDIF
+
+   END function agrif_external_switch_index
+
+   SUBROUTINE Correct_field(tab2d,i1,i2,j1,j2)
+      !!----------------------------------------------------------------------
+      !!                   *** ROUTINE Correct_field ***
+      !!----------------------------------------------------------------------
+   
+   USE dom_oce
+   USE agrif_oce
+
+   INTEGER :: i1,i2,j1,j2
+   REAL(wp), DIMENSION(i1:i2,j1:j2) :: tab2d
+
+   INTEGER :: i,j
+   REAL(wp), DIMENSION(i1:i2,j1:j2) :: tab2dtemp
+
+   tab2dtemp = tab2d
+
+   IF( .NOT. use_sign_north ) THEN
+      DO j=j1,j2
+         DO i=i1,i2
+            tab2d(i,j)=tab2dtemp(i2-(i-i1),j2-(j-j1))
+         END DO
+      END DO
+   ELSE
+      DO j=j1,j2
+         DO i=i1,i2
+            tab2d(i,j)=sign_north * tab2dtemp(i2-(i-i1),j2-(j-j1))
+         END DO
+      END DO
+   ENDIF
+
+   END SUBROUTINE Correct_field
+
 #else
    SUBROUTINE Subcalledbyagrif
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/dom_oce.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/dom_oce.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/dom_oce.F90	(revision 13026)
@@ -215,4 +215,5 @@
 #if defined key_agrif
    LOGICAL, PUBLIC, PARAMETER ::   lk_agrif = .TRUE.    !: agrif flag
+   LOGICAL, PUBLIC            ::   lk_south, lk_north, lk_west, lk_east !: Child grid boundaries (interpolation or not)
 #else
    LOGICAL, PUBLIC, PARAMETER ::   lk_agrif = .FALSE.   !: agrif flag
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/domain.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/domain.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/domain.F90	(revision 13026)
@@ -187,6 +187,11 @@
       ENDIF
       !
+
       IF( lk_c1d         )   CALL cor_c1d       ! 1D configuration: Coriolis set at T-point
       !
+
+#if defined key_agrif
+      IF( .NOT. Agrif_Root() ) CALL Agrif_Init_Domain( Kbb, Kmm, Kaa )
+#endif
       IF( ln_meshmask    )   CALL dom_wri       ! Create a domain file
       IF( .NOT.ln_rstart )   CALL dom_ctl       ! Domain control
@@ -307,4 +312,11 @@
 902   IF( ios >  0 )   CALL ctl_nam ( ios , 'namrun in configuration namelist' )
       IF(lwm) WRITE ( numond, namrun )
+
+#if defined key_agrif
+      IF( .NOT. Agrif_Root() ) THEN
+            nn_it000 = (Agrif_Parent(nn_it000)-1)*Agrif_IRhot() + 1
+            nn_itend =  Agrif_Parent(nn_itend)   *Agrif_IRhot()
+      ENDIF
+#endif
       !
       IF(lwp) THEN                  ! control print
@@ -403,4 +415,10 @@
       IF(lwm) WRITE( numond, namdom )
       !
+#if defined key_agrif
+      IF( .NOT. Agrif_Root() ) THEN
+            rn_Dt = Agrif_Parent(rn_Dt) / Agrif_Rhot()
+      ENDIF
+#endif
+      !
       IF(lwp) THEN
          WRITE(numout,*)
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/istate.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/istate.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DOM/istate.F90	(revision 13026)
@@ -35,4 +35,8 @@
    USE lib_mpp         ! MPP library
    USE restart         ! restart
+#if defined key_agrif
+   USE agrif_oce_interp
+   USE agrif_oce
+#endif   
 
    IMPLICIT NONE
@@ -70,5 +74,5 @@
 !!gm  Why not include in the first call of dta_tsd ?  
 !!gm  probably associated with the use of internal damping...
-                     CALL dta_tsd_init        ! Initialisation of T & S input data
+       CALL dta_tsd_init        ! Initialisation of T & S input data
 !!gm to be moved in usrdef of C1D case
 !      IF( lk_c1d )   CALL dta_uvd_init        ! Initialization of U & V input data
@@ -97,7 +101,15 @@
          !
          IF( ln_tsd_init ) THEN               
-            CALL dta_tsd( nit000, ts(:,:,:,:,Kbb) )       ! read 3D T and S data at nit000
+            IF( Agrif_root() ) THEN
+               CALL dta_tsd( nit000, ts(:,:,:,:,Kbb) )       ! read 3D T and S data at nit000
+               ssh(:,:,Kbb)   = 0._wp               ! set the ocean at rest
+               uu  (:,:,:,Kbb) = 0._wp
+               vv  (:,:,:,Kbb) = 0._wp  
+#if defined key_agrif
+            ELSE
+               CALL agrif_istate( Kbb, Kmm, Kaa ) 
+#endif
+            ENDIF
             !
-            ssh(:,:,Kbb)   = 0._wp               ! set the ocean at rest
             IF( ll_wd ) THEN
                ssh(:,:,Kbb) =  -ssh_ref  ! Added in 30 here for bathy that adds 30 as Iterative test CEOD 
@@ -111,7 +123,5 @@
                END_2D
             ENDIF 
-            uu  (:,:,:,Kbb) = 0._wp
-            vv  (:,:,:,Kbb) = 0._wp  
-            !
+             !
          ELSE                                 ! user defined initial T and S
             CALL usr_def_istate( gdept(:,:,:,Kbb), tmask, ts(:,:,:,:,Kbb), uu(:,:,:,Kbb), vv(:,:,:,Kbb), ssh(:,:,Kbb)  )         
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DYN/sshwzv.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DYN/sshwzv.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/DYN/sshwzv.F90	(revision 13026)
@@ -204,31 +204,40 @@
          ! Mask vertical velocity at first/last columns/row 
          ! inside computational domain (cosmetic) 
-         ! --- West --- !
-         DO ji = mi0(2), mi1(2)
-            DO jj = 1, jpj
-               pww(ji,jj,:) = 0._wp 
+         ! --- West --- !         
+         IF( lk_west) THEN
+            DO ji = mi0(2), mi1(2)
+               DO jj = 1, jpj
+                  pww(ji,jj,:) = 0._wp 
+               ENDDO
             ENDDO
-         ENDDO
+         ENDIF
          !
          ! --- East --- !
-         DO ji = mi0(jpiglo-1), mi1(jpiglo-1)
-            DO jj = 1, jpj
-               pww(ji,jj,:) = 0._wp
+         IF( lk_east) THEN
+            DO ji = mi0(jpiglo-1), mi1(jpiglo-1)
+               DO jj = 1, jpj
+                  pww(ji,jj,:) = 0._wp
+               ENDDO
             ENDDO
-         ENDDO
+         ENDIF
          !
          ! --- South --- !
-         DO jj = mj0(2), mj1(2)
-            DO ji = 1, jpi
-               pww(ji,jj,:) = 0._wp
+         IF( lk_south) THEN
+            DO jj = mj0(2), mj1(2)
+               DO ji = 1, jpi
+                  pww(ji,jj,:) = 0._wp
+               ENDDO
             ENDDO
-         ENDDO
+         ENDIF
          !
          ! --- North --- !
-         DO jj = mj0(jpjglo-1), mj1(jpjglo-1)
-            DO ji = 1, jpi
-               pww(ji,jj,:) = 0._wp
+         IF( lk_north) THEN
+            DO jj = mj0(jpjglo-1), mj1(jpjglo-1)
+               DO ji = 1, jpi
+                  pww(ji,jj,:) = 0._wp
+               ENDDO
             ENDDO
-         ENDDO
+         ENDIF
+         !
       ENDIF 
 #endif 
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/FLO/floblk.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/FLO/floblk.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/FLO/floblk.F90	(revision 13026)
@@ -41,4 +41,8 @@
       INTEGER, INTENT( in  ) ::   Kbb, Kmm ! ocean time level indices
       !!
+#ifndef key_agrif
+
+!RB super quick fix to compile with agrif
+
       INTEGER :: jfl              ! dummy loop arguments
       INTEGER :: ind, ifin, iloop
@@ -364,4 +368,5 @@
          GO TO 222
       ENDIF
+#endif
       !
       !
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/LBC/lib_mpp.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/LBC/lib_mpp.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/LBC/lib_mpp.F90	(revision 13026)
@@ -137,7 +137,7 @@
 
    ! Communications summary report
-   CHARACTER(len=128), DIMENSION(:), ALLOCATABLE ::   crname_lbc                   !: names of lbc_lnk calling routines
-   CHARACTER(len=128), DIMENSION(:), ALLOCATABLE ::   crname_glb                   !: names of global comm calling routines
-   CHARACTER(len=128), DIMENSION(:), ALLOCATABLE ::   crname_dlg                   !: names of delayed global comm calling routines
+   CHARACTER(len=lca), DIMENSION(:), ALLOCATABLE ::   crname_lbc                   !: names of lbc_lnk calling routines
+   CHARACTER(len=lca), DIMENSION(:), ALLOCATABLE ::   crname_glb                   !: names of global comm calling routines
+   CHARACTER(len=lca), DIMENSION(:), ALLOCATABLE ::   crname_dlg                   !: names of delayed global comm calling routines
    INTEGER, PUBLIC                               ::   ncom_stp = 0                 !: copy of time step # istp
    INTEGER, PUBLIC                               ::   ncom_fsbc = 1                !: copy of sbc time step # nn_fsbc
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/LBC/mppini.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/LBC/mppini.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/LBC/mppini.F90	(revision 13026)
@@ -102,4 +102,9 @@
             &           'the domain is lay out for distributed memory computing!' )
          !
+#if defined key_agrif
+    IF (.NOT.agrif_root()) THEN
+      call agrif_nemo_init()
+    ENDIF
+#endif
    END SUBROUTINE mpp_init
 
@@ -333,9 +338,5 @@
 #if defined key_agrif
       IF( .NOT. Agrif_Root() ) THEN       ! AGRIF children: specific setting (cf. agrif_user.F90)
-         IF( jpiglo /= nbcellsx + 2 + 2*nbghostcells )   &
-            CALL ctl_stop( 'STOP', 'mpp_init: Agrif children requires jpiglo == nbcellsx + 2 + 2*nbghostcells' )
-         IF( jpjglo /= nbcellsy + 2 + 2*nbghostcells )   &
-            CALL ctl_stop( 'STOP', 'mpp_init: Agrif children requires jpjglo == nbcellsy + 2 + 2*nbghostcells' )
-         IF( ln_use_jattr )   CALL ctl_stop( 'STOP', 'mpp_init:Agrif children requires ln_use_jattr = .false. ' )
+         CALL agrif_nemo_init()
       ENDIF
 #endif
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/OBS/diaobs.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/OBS/diaobs.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/OBS/diaobs.F90	(revision 13026)
@@ -94,5 +94,5 @@
    TYPE(obs_prof), PUBLIC, POINTER, DIMENSION(:) ::   profdataqc   !: Profile data after quality control
 
-   CHARACTER(len=6), PUBLIC, DIMENSION(:), ALLOCATABLE ::   cobstypesprof, cobstypessurf   !: Profile & surface obs types
+   CHARACTER(len=lca), PUBLIC, DIMENSION(:), ALLOCATABLE ::   cobstypesprof, cobstypessurf   !: Profile & surface obs types
 
    !!----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/SBC/sbcmod.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/SBC/sbcmod.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/SBC/sbcmod.F90	(revision 13026)
@@ -122,8 +122,8 @@
       !                             !* overwrite namelist parameter using CPP key information
 #if defined key_agrif
-      IF( Agrif_Root() ) THEN                ! AGRIF zoom (cf r1242: possibility to run without ice in fine grid)
-         IF( lk_si3  )   nn_ice      = 2
-         IF( lk_cice )   nn_ice      = 3
-      ENDIF
+ !     IF( Agrif_Root() ) THEN                ! AGRIF zoom (cf r1242: possibility to run without ice in fine grid)
+ !        IF( lk_si3  )   nn_ice      = 2
+ !        IF( lk_cice )   nn_ice      = 3
+ !     ENDIF
 !!GS: TBD
 !#else
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/STO/stopar.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/STO/stopar.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/STO/stopar.F90	(revision 13026)
@@ -56,6 +56,6 @@
    INTEGER,          DIMENSION(:),       ALLOCATABLE :: sto3d_ord  ! order of autoregressive process
 
-   CHARACTER(len=1), DIMENSION(:),       ALLOCATABLE :: sto2d_typ  ! nature of grid point (T, U, V, W, F, I)
-   CHARACTER(len=1), DIMENSION(:),       ALLOCATABLE :: sto3d_typ  ! nature of grid point (T, U, V, W, F, I)
+   CHARACTER(len=lca), DIMENSION(:),       ALLOCATABLE :: sto2d_typ  ! nature of grid point (T, U, V, W, F, I)
+   CHARACTER(len=lca), DIMENSION(:),       ALLOCATABLE :: sto3d_typ  ! nature of grid point (T, U, V, W, F, I)
    REAL(wp),         DIMENSION(:),       ALLOCATABLE :: sto2d_sgn  ! control of the sign accross the north fold
    REAL(wp),         DIMENSION(:),       ALLOCATABLE :: sto3d_sgn  ! control of the sign accross the north fold
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/USR/usrdef_hgr.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/USR/usrdef_hgr.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/USR/usrdef_hgr.F90	(revision 13026)
@@ -95,4 +95,5 @@
 #if defined key_agrif
       ! ! Upper left longitude and latitude from parent:
+      ! Laurent: Should be modify in case of an east-west cyclic parent grid
       IF (.NOT.Agrif_root()) THEN
          zlam0 = zlam1 + Agrif_irhox() * REAL(Agrif_Parent(jpjglo)-2 , wp) * ze1deg * zcos_alpha  &
Index: NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/USR/usrdef_nam.F90
===================================================================
--- NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/USR/usrdef_nam.F90	(revision 13023)
+++ NEMO/branches/2020/dev_r12973_AGRIF_CMEMS/src/OCE/USR/usrdef_nam.F90	(revision 13026)
@@ -74,6 +74,6 @@
 #if defined key_agrif
       IF( .NOT. Agrif_Root() ) THEN
-         kpi  = nbcellsx + 2 + 2*nbghostcells
-         kpj  = nbcellsy + 2 + 2*nbghostcells
+         kpi  = nbcellsx + 2 + 2*nbghostcells_x
+         kpj  = nbcellsy + 2 + 2*nbghostcells_y_s
       ENDIF
 #endif
